(*************************************************************************)
(*                                                                       *)
(*                         N-Mice Simulation                             *)
(*                                                                       *)
(* Author: Arash Partow                                                  *)
(*                                                                       *)
(* Copyright notice:                                                     *)
(* Free use of the N-Mice Simulation is permitted under the  guidelines  *)
(* and in accordance with the most current version  of the Common Public *)
(* License.                                                              *)
(* http://www.opensource.org/licenses/cpl.php                            *)
(*                                                                       *)
(*************************************************************************)

unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, 
  Classes, Graphics, Controls, Forms,
  Dialogs, Menus,    ExtCtrls, StdCtrls,
  Mouse_Bk, ComCtrls, AboutBoxUnit;

type
  TMainMouseForm = class(TForm)
    MainMenu1   : TMainMenu;
    File1       : TMenuItem;
    Exit1       : TMenuItem;
    About1      : TMenuItem;
    ControlPanel: TPanel;
    Button1     : TButton;
    Button2     : TButton;
    UpDown1     : TUpDown;
    Edit1       : TEdit;
    Timer1      : TTimer;
    Splitter1   : TSplitter;
    ImagePanel  : TPanel;
    PaintBox1   : TPaintBox;
    procedure Exit1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure About1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainMouseForm: TMainMouseForm;
  NoChase      : Boolean;

implementation

{$R *.dfm}

procedure TMainMouseForm.FormCreate(Sender: TObject);
begin
 MICE:=5;
 UpDown1.Position:=MICE;
 Edit1.Text:=IntToStr(MICE);
 NoChase:=True;
 ImagePanel.DoubleBuffered:=True;
 DoubleBuffered:=True;
end;

procedure TMainMouseForm.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  MICE:=UpDown1.Position;
  Edit1.Text:=IntToStr(MICE);
  InitialiseMice;
  SetupGraphicScreen(PaintBox1.Canvas);
  DrawShapeBoarder(PaintBox1.Canvas);
  NoChase:=False;
end;


procedure TMainMouseForm.Exit1Click(Sender: TObject);
begin
 close();
end;

procedure TMainMouseForm.Button1Click(Sender: TObject);
begin
 close();
end;

procedure TMainMouseForm.Button2Click(Sender: TObject);
begin
 InitialiseMice;
 SetupGraphicScreen(PaintBox1.Canvas);
 DrawShapeBoarder(PaintBox1.Canvas);
 NoChase:=False;
end;



procedure TMainMouseForm.Timer1Timer(Sender: TObject);
begin
 If Not NoChase Then
  Begin
  If Round(Distance(Mouse[0].proj.xVal,Mouse[0].proj.yVal,
                    Mouse[1].proj.xVal,mouse[1].proj.yVal)) > 1 Then
   Begin
    DoMouseChase;
    DrawMice(PaintBox1.Canvas);
   end
    else
     Begin
      InterceptComplete(PaintBox1.Canvas);
      NoChase:=True;
     End;
  End;

end;


procedure TMainMouseForm.About1Click(Sender: TObject);
begin
 AboutBoxForm.Show;
end;


procedure TMainMouseForm.FormResize(Sender: TObject);
begin
 Height := 665;
 Width  := 730;
end;

end.
